import .connectives
import .leibniz
import .relations
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O).
theorem nat.eq_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O)) ((((@nat.axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
theorem nat.sym_eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((case_S) (n))) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
noncomputable def nat.pred_ : (nat.nat) -> nat.nat := fun (n : nat.nat) , ((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n).
constant nat.le_ : (nat.nat) -> (nat.nat) -> Prop.
axiom nat.le_n : forall (n:nat.nat) , (((nat.le_) ) (n)) (n).
axiom nat.le_S : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((nat.le_) ) (n)) (((nat.S) ) (m)).
axiom nat.le_ind : forall (n:nat.nat) , forall (Q:(nat.nat) -> Prop) , ((Q) (n)) -> (forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> ((Q) (m)) -> (Q) (((nat.S) ) (m))) -> forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (Q) (m).
theorem nat.le_n_Sn : forall (n:nat.nat) , (((nat.le_) ) (n)) (((nat.S) ) (n)) := fun (n : nat.nat) , (((@nat.le_S) (n)) (n)) ((@nat.le_n) (n)).
theorem nat.transitive_le : ((relations.transitive) (nat.nat)) ((nat.le_) ) := fun (a : nat.nat) , fun (b : nat.nat) , fun (c : nat.nat) , fun (leab : (((nat.le_) ) (a)) (b)) , (fun (lebc : (((nat.le_) ) (b)) (c)) , (((((((@nat.le_ind) (b)) (fun (x_417 : nat.nat) , (((nat.le_) ) (a)) (x_417))) (leab)) (fun (m : nat.nat) , fun (_x_419 : (((nat.le_) ) (b)) (m)) , (fun (_x_421 : (((nat.le_) ) (a)) (m)) , ((((@nat.le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
theorem nat.le_pred_n : forall (n:nat.nat) , (((nat.le_) ) (((nat.pred_) ) (n))) (n) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((nat.le_) ) (((nat.pred_) ) (_x_365))) (_x_365))) ((((((@nat.eq_match_nat_type_O) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (fun (y : nat.nat) , (((nat.le_) ) (((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) ((nat.O) ))) (y))) ((@nat.le_n) (((nat.pred_) ) ((nat.O) ))))) (fun (x_366 : nat.nat) , fun (_x_368 : (((nat.le_) ) (((nat.pred_) ) (x_366))) (x_366)) , (((((((@nat.eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (x_366)) (fun (y : nat.nat) , (((nat.le_) ) (((nat.pred_) ) (((nat.S) ) (x_366)))) (((nat.S) ) (y)))) ((@nat.le_n_Sn) (((nat.pred_) ) (((nat.S) ) (x_366))))))) (n).
theorem nat.monotonic_pred : (((relations.monotonic) (nat.nat)) ((nat.le_) )) ((nat.pred_) ) := fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (((((((@nat.le_ind) (n)) (fun (x_417 : nat.nat) , (((nat.le_) ) (((nat.pred_) ) (n))) (((nat.pred_) ) (x_417)))) ((@nat.le_n) (((nat.pred_) ) (n)))) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (n)) (m0)) , (fun (_x_421 : (((nat.le_) ) (((nat.pred_) ) (n))) (((nat.pred_) ) (m0))) , ((((((@nat.transitive_le) (((nat.pred_) ) (n))) (n)) (((nat.pred_) ) (((nat.S) ) (m0)))) ((@nat.le_pred_n) (n))) (((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (m0)) (fun (y : nat.nat) , (((nat.le_) ) (n)) (y))) (_x_419)))))) (m)) (lenm)).
theorem nat.le_S_S_to_le : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m))) -> (((nat.le_) ) (n)) (m) := fun (n : nat.nat) , fun (m : nat.nat) , fun (auto : (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m))) , (((((((@nat.eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (m)) (fun (y : nat.nat) , (((nat.le_) ) (n)) (y))) (((((((@nat.eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n)) (fun (y : nat.nat) , (((nat.le_) ) (y)) (((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (((nat.S) ) (m))))) ((((@nat.monotonic_pred) (((nat.S) ) (n))) (((nat.S) ) (m))) (auto)))).
